; Assemblerquelltext des RONPAS-Compilers (c) by Ronald Daleske
; PROGRAM-NAME: DWORD.PAS
 
.nolist
.INCLUDE "m644Pdef.inc"
.list
 
; *** Konstantentabelle ***
 
.equ        DW2  =  0x05E30A77 ; DWORD
.equ        DW3  =  0x000004D2 ; DWORD
.equ        W2  =  0x223D ; WORD
.equ        W3  =  0x04D2 ; WORD
.equ        B2  =  0x0C ; BYTE
.equ        B3  =  0x59 ; BYTE
 
; *** Variablentabelle ***
 
.dseg
 
DW1:   ; DWord
.byte     4
DW5:   ; DWord
.byte     4
W1:   ; Word
.byte     2
B1:   ; Byte
.byte     1
 
 
 
; *** Codesegment ***
.cseg
 
; *** Sprungtabelle ***
.ORG 0
 
; Sprung in das Hauptprogramm
        JMP       RESET
 
; FUNCTION - Anfang (P1)
P1:
 
; RESULT DWord-Variable - FUNCTION (P1)
        LDS        R4, DW5
        LDS        R5, DW5+1
        LDS        R6, DW5+2
        LDS        R7, DW5+3
 
; Ende DWord - FUNCTION (P1)
        MOV        R16, R4
        MOV        R17, R5
        MOV        R18, R6
        MOV        R19, R7
 
; FUNCTION - Ende (P1)
        RET
 
; PROCEDURE - Anfang (P2)
P2:
 
; Retten der lokalen Parameter fuer PROCEDURE (P2)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
        PUSH       R8
        PUSH       R9
        PUSH       R10
 
; Parameter (DW4) retten
        MOV        R20, R4
        MOV        R21, R5
        MOV        R22, R6
        MOV        R23, R7
 
; lokalen Parameter (DW4) an Funktion (P1)
        MOV        R0, R20
        MOV        R1, R21
        MOV        R2, R22
        MOV        R3, R23
 
; Aufruf Funktion (P1)
        CALL       P1
 
; Retten der Parameter-Register fuer PROCEDURE (P2)
        POP        R10
        POP        R9
        POP        R8
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  VAR (DW1)
        STS        DW1, R16
        STS        DW1+1, R17
        STS        DW1+2, R18
        STS        DW1+3, R19
 
; IF THEN - Ausdruck erster Faktor / DWord-VAR (DW1)
        LDS        R16, DW1
        LDS        R17, DW1+1
        LDS        R18, DW1+2
        LDS        R19, DW1+3
 
; IF THEN - Ausdruck zweiter Faktor / DWord-VAR (DW5)
        LDS        R20, DW5
        LDS        R21, DW5+1
        LDS        R22, DW5+2
        LDS        R23, DW5+3
 
; Operator >=
        CP         R16, R20
        CPC        R17, R21
        CPC        R18, R22
        CPC        R19, R23
        BRCC       M_VERGL_04
        CLR        R16
        RJMP       M_VERGL_05
M_VERGL_04:
        SER        R16
M_VERGL_05:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_01
        RJMP       M_IF_02
M_IF_01:
 
; IF_THEN - Ende
M_IF_02:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (00000004)
        LDI        R16, 0x04
        LDI        R17, 0x00
        LDI        R18, 0x00
        LDI        R19, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (DW4)
        MOV        R4, R16
        MOV        R5, R17
        MOV        R6, R18
        MOV        R7, R19
 
; Zuweisung Quelle - Ausdruck / DWByte(0,DW4)
        MOV        R16, R4
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B2A)
        MOV        R10, R16
 
; Zuweisung Quelle - Ausdruck / DWByte(1,DW4)
        MOV        R16, R5
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B2A)
        MOV        R10, R16
 
; Zuweisung Quelle - Ausdruck / DWByte(2,DW4)
        MOV        R16, R6
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B2A)
        MOV        R10, R16
 
; Zuweisung Quelle - Ausdruck / DWByte(3,DW4)
        MOV        R16, R7
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B2A)
        MOV        R10, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (DW4)
        MOV        R16, R4
        MOV        R17, R5
        MOV        R18, R6
        MOV        R19, R7
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (00010000)
        LDI        R20, 0x00
        LDI        R21, 0x00
        LDI        R22, 0x01
        LDI        R23, 0x00
 
; Operator +
        ADD        R16, R20
        ADC        R17, R21
        ADC        R18, R22
        ADC        R19, R23
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (DW4)
        MOV        R4, R16
        MOV        R5, R17
        MOV        R6, R18
        MOV        R7, R19
 
; PROCEDURE - Ende (P2)
        RET
 
; Start des Hauptprogramms
RESET:
 
; Initialisieren des Stacks
        LDI        R16, LOW(RAMEND)
        OUT        SPL, R16
        LDI        R16, HIGH(RAMEND)
        OUT        SPH, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / Zahlenwert (00000005)
        LDI        R16, 0x05
        LDI        R17, 0x00
        LDI        R18, 0x00
        LDI        R19, 0x00
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0000007B)
        LDI        R20, 0x7B
        LDI        R21, 0x00
        LDI        R22, 0x00
        LDI        R23, 0x00
 
; Operator +
        ADD        R16, R20
        ADC        R17, R21
        ADC        R18, R22
        ADC        R19, R23
 
; Zuweisung Ziel /  VAR (DW1)
        STS        DW1, R16
        STS        DW1+1, R17
        STS        DW1+2, R18
        STS        DW1+3, R19
 
; INC(DW1) - DWord
        LDS        R16, DW1
        LDS        R17, DW1+1
        LDS        R18, DW1+2
        LDS        R19, DW1+3
        CLR        R24
        SEC
        ADC        R16, R24
        ADC        R17, R24
        ADC        R18, R24
        ADC        R19, R24
        STS        DW1, R16
        STS        DW1+1, R17
        STS        DW1+2, R18
        STS        DW1+3, R19
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (000004D2)
        LDI        R16, 0xD2
        LDI        R17, 0x04
        LDI        R18, 0x00
        LDI        R19, 0x00
 
; Zuweisung Ziel /  VAR (DW1)
        STS        DW1, R16
        STS        DW1+1, R17
        STS        DW1+2, R18
        STS        DW1+3, R19
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0000162E)
        LDI        R16, 0x2E
        LDI        R17, 0x16
        LDI        R18, 0x00
        LDI        R19, 0x00
 
; Zuweisung Ziel /  VAR (DW5)
        STS        DW5, R16
        STS        DW5+1, R17
        STS        DW5+2, R18
        STS        DW5+3, R19
 
; Zuweisung Quelle - Ausdruck erster Faktor / DWord-VAR (DW1)
        LDS        R16, DW1
        LDS        R17, DW1+1
        LDS        R18, DW1+2
        LDS        R19, DW1+3
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / DWord-VAR (DW5)
        LDS        R20, DW5
        LDS        R21, DW5+1
        LDS        R22, DW5+2
        LDS        R23, DW5+3
 
; Operator *
        CALL       ASM_UP_MUL32
 
; Zuweisung Ziel /  VAR (DW5)
        STS        DW5, R16
        STS        DW5+1, R17
        STS        DW5+2, R18
        STS        DW5+3, R19
 
; IF THEN - Ausdruck erster Faktor / DWord-VAR (DW1)
        LDS        R16, DW1
        LDS        R17, DW1+1
        LDS        R18, DW1+2
        LDS        R19, DW1+3
 
; IF THEN - Ausdruck zweiter Faktor / DWord-VAR (DW5)
        LDS        R20, DW5
        LDS        R21, DW5+1
        LDS        R22, DW5+2
        LDS        R23, DW5+3
 
; Operator >=
        CP         R16, R20
        CPC        R17, R21
        CPC        R18, R22
        CPC        R19, R23
        BRCC       M_VERGL_09
        CLR        R16
        RJMP       M_VERGL_010
M_VERGL_09:
        SER        R16
M_VERGL_010:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_06
        RJMP       M_IF_07
M_IF_06:
 
; IF_THEN - Ende
M_IF_07:
 
; Zuweisung Quelle - Ausdruck erster Faktor / DWord-VAR (DW1)
        LDS        R16, DW1
        LDS        R17, DW1+1
        LDS        R18, DW1+2
        LDS        R19, DW1+3
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (00000001)
        LDI        R20, 0x01
        LDI        R21, 0x00
        LDI        R22, 0x00
        LDI        R23, 0x00
 
; Operator -
        SUB        R16, R20
        SBC        R17, R21
        SBC        R18, R22
        SBC        R19, R23
 
; Zuweisung Ziel /  VAR (DW5)
        STS        DW5, R16
        STS        DW5+1, R17
        STS        DW5+2, R18
        STS        DW5+3, R19
 
; Zuweisung Quelle - Ausdruck / DWByte(0,DW1)
        LDS        R16, DW1
 
; Zuweisung Ziel /  VAR (B1)
        STS        B1, R16
 
; Zuweisung Quelle - Ausdruck / DWByte(1,DW1)
        LDS        R16, DW1+1
 
; Zuweisung Ziel /  VAR (B1)
        STS        B1, R16
 
; Zuweisung Quelle - Ausdruck / DWByte(2,DW1)
        LDS        R16, DW1+2
 
; Zuweisung Ziel /  VAR (B1)
        STS        B1, R16
 
; Zuweisung Quelle - Ausdruck / DWByte(3,DW1)
        LDS        R16, DW1+3
 
; Zuweisung Ziel /  VAR (B1)
        STS        B1, R16
 
; Zuweisung Quelle - Ausdruck / DWByte(0,DW2)
        LDI        R16, 0x77
 
; Zuweisung Ziel /  VAR (B1)
        STS        B1, R16
 
; Zuweisung Quelle - Ausdruck / DWByte(1,DW2)
        LDI        R16, 0x0A
 
; Zuweisung Ziel /  VAR (B1)
        STS        B1, R16
 
; Zuweisung Quelle - Ausdruck / DWByte(2,DW2)
        LDI        R16, 0xE3
 
; Zuweisung Ziel /  VAR (B1)
        STS        B1, R16
 
; Zuweisung Quelle - Ausdruck / DWByte(3,DW2)
        LDI        R16, 0x05
 
; Zuweisung Ziel /  VAR (B1)
        STS        B1, R16
 
; *** Unterprogramm Bibliothek ***
; Multiplikation von 2 32-Bit Zahlen (DWORD)
; Quelle: Mikrocomputertechnik mit Controllern der Atmel AVR-RISC-Familie
;         Guenter Schmitt, ISBN 978-3-486-58988-7
; Version 1.0, Stand 11.01.2013
;
; Uebergabe: R16:R17:18:19 erster Faktor
;            R20:R21:22:23 zweiter Faktor
; Temporaere Register: R24,R25,R26,R27,R28
;                      R20,R21,R22,R23,R24
ASM_UP_MUL32:

        PUSH       R0
        PUSH       R1

        CLR        R28
        MUL        R21, R17
        MOVW       R27:R26, R1:R0
        MUL        R20, R16
        MOVW       R25:R24, R1:R0
        MUL        R21, R16
        ADD        R25, R0
        ADC        R26, R1
        ADC        R27, R28
        MUL        R17, R20
        ADD        R25, R0
        ADC        R26, R1
        ADC        R27, R28
        MOVW       R17:R16, R25:R24       ; Produkt Low
        MOVW       R19:R18, R27:R26       ; Produkt High

        POP        R1
        POP        R0		

        RET






 
; *** Namen-Liste ***
;
; DW2 (C) DWORD Wert=05E30A77
; DW3 (C) DWORD Wert=000004D2
; W2 (C) WORD Wert=0x223D
; W3 (C) WORD Wert=0x04D2
; B2 (C) BYTE Wert=0x0C
; B3 (C) BYTE Wert=0x59
; DW1 (V) DWORD
; DW5 (V) DWORD
; W1 (V) WORD
; B1 (V) BYTE
; P1 (F) 
; P2 (P) 
 
; *** Prozedur/Function-Liste ***
;
; FUNCTION P1 (A2 : DWORD) : DWORD;
; PROCEDURE P2 (A1 : DWORD) (DW4 : DWORD) (W2A : WORD) (B2A : BYTE);
 
