; Assemblerquelltext des RONPAS-Compilers (c) by Ronald Daleske
; PROGRAM-NAME: TEST_SER.PAS
 
.nolist
.INCLUDE "m644Pdef.inc"
.list
 
; *** Konstantentabelle ***
 
.equ        BAUDRATE  =  0x62A5 ; WORD
.equ        UBRR_VAL  =  0x0031 ; WORD
.equ        XON  =  0x11 ; BYTE
.equ        XOFF  =  0x13 ; BYTE
 
; *** Variablentabelle ***
 
.dseg
 
ZEICHEN:   ; Byte
.byte     1
EMPFANGENES_ZEICHEN:   ; Byte
.byte     1
 
 
 
; *** Codesegment ***
.cseg
 
; *** Sprungtabelle ***
.ORG 0
 
; Sprung in das Hauptprogramm
        JMP       RESET
 
; PROCEDURE - Anfang (INIT_SER_PORT)
INIT_SER_PORT:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (UBRR_VAL)
        LDI        R16, LOW(0x0031)
        LDI        R17, HIGH(0x0031)
 
; Zuweisung Ziel /  VAR (UBRR0)
        STS        UBRR0, R16
        STS        UBRR0+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x18)
        LDI        R16, 0x18
 
; Zuweisung Ziel /  VAR (UCSR0B)
        STS        UCSR0B, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x86)
        LDI        R16, 0x86
 
; Zuweisung Ziel /  VAR (UCSR0C)
        STS        UCSR0C, R16
 
; PROCEDURE - Ende (INIT_SER_PORT)
        RET
 
; PROCEDURE - Anfang (SENDE_ZEICHEN)
SENDE_ZEICHEN:
 
; WHILE DO ...
M_WHILE_01:
 
; WHILE - Ausdruck /; BitLow(UDRE0)
        LDS        R16, UCSR0A
        BST        R16, 5
        BRTC       M_VERGL_04
        CLR        R16
        RJMP       M_VERGL_05
M_VERGL_04:
        SER        R16
M_VERGL_05:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_02
        RJMP       M_WHILE_03
M_WHILE_02:
 
; SetBit(LED_ROT)
        SBI        PORTD, 7
 
; WHILE DO ...
        RJMP       M_WHILE_01
M_WHILE_03:
 
; ClearBit(LED_ROT)
        CBI        PORTD, 7
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (ZEICHEN)
        LDS        R16, ZEICHEN
 
; Zuweisung Ziel /  VAR (UDR0)
        STS        UDR0, R16
 
; PROCEDURE - Ende (SENDE_ZEICHEN)
        RET
 
; PROCEDURE - Anfang (RX_PUFFER_ABFRAGEN)
RX_PUFFER_ABFRAGEN:
 
; IF THEN - Ausdruck /; BitHigh(RXC0)
        LDS        R16, UCSR0A
        BST        R16, 7
        BRTS       M_VERGL_09
        CLR        R16
        RJMP       M_VERGL_010
M_VERGL_09:
        SER        R16
M_VERGL_010:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_06
        RJMP       M_IF_07
M_IF_06:
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (UDR0)
        LDS        R16, UDR0
 
; Zuweisung Ziel /  VAR (EMPFANGENES_ZEICHEN)
        STS        EMPFANGENES_ZEICHEN, R16
 
; IF_THEN - Ende
M_IF_07:
 
; PROCEDURE - Ende (RX_PUFFER_ABFRAGEN)
        RET
 
; Start des Hauptprogramms
RESET:
 
; Initialisieren des Stacks
        LDI        R16, LOW(RAMEND)
        OUT        SPL, R16
        LDI        R16, HIGH(RAMEND)
        OUT        SPH, R16
 
; ASM
.equ UBRR0 = UBRR0L

 
 
; *** Namen-Liste ***
;
; BAUDRATE (C) WORD Wert=0x62A5
; UBRR_VAL (C) WORD Wert=0x0031
; XON (C) BYTE Wert=0x11
; XOFF (C) BYTE Wert=0x13
; PORTD (V) BYTECONREG
; DDRD (V) BYTECONREG
; PIND (V) BYTECONREG
; PORTC (V) BYTECONREG
; DDRC (V) BYTECONREG
; PINC (V) BYTECONREG
; PORTB (V) BYTECONREG
; DDRB (V) BYTECONREG
; PINB (V) BYTECONREG
; PORTA (V) BYTECONREG
; DDRA (V) BYTECONREG
; PINA (V) BYTECONREG
; UBRR0H (V) BYTECONVAR
; UBRR0L (V) BYTECONVAR
; UCSR0C (V) BYTECONVAR
; UCSR0B (V) BYTECONVAR
; UCSR0A (V) BYTECONVAR
; UDR0 (V) BYTECONVAR
; UBRR0 (V) WORDCONVAR
; RXC0 (B) BIT
; TXC0 (B) BIT
; UDRE0 (B) BIT
; LED_ROT (B) BIT
; ZEICHEN (V) BYTE
; EMPFANGENES_ZEICHEN (V) BYTE
; INIT_SER_PORT (P) 
; SENDE_ZEICHEN (P) 
; RX_PUFFER_ABFRAGEN (P) 
 
; *** Prozedur/Function-Liste ***
;
; PROCEDURE INIT_SER_PORT;
; PROCEDURE SENDE_ZEICHEN;
; PROCEDURE RX_PUFFER_ABFRAGEN;
 
