; Assemblerquelltext des RONPAS-Compilers (c) by Ronald Daleske
; PROGRAM-NAME: TEST_STRING.PAS
 
.nolist
.INCLUDE "m644Pdef.inc"
.list
 
; *** Variablentabelle ***
 
.dseg
 
S1:   ; String(10)
.byte     1     ; STRING-Laenge
.byte     10
WRITE_STRING:   ; String(20)
.byte     1     ; STRING-Laenge
.byte     20
C2:   ; Char
.byte     1
RAM_ZELLE:   ; Byte
.byte     1
 
 
 
; *** Codesegment ***
.cseg
 
; *** Sprungtabelle ***
.ORG 0
 
; Sprung in das Hauptprogramm
        JMP       RESET
 
; PROCEDURE - Anfang (SENDE_STRING)
SENDE_STRING:
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (S1)=10
        LDI        R16, 10
        CLR        R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (C1)
        MOV        R19, R0
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_01
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_01:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Kopieren der String-Konstante in den Stack ('Hallo')
        LDI        ZL, LOW(2*M_CONST_STRING_0)
        LDI        ZH, HIGH(2*M_CONST_STRING_0)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_02
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_02:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_04
M_PRG_CONST_STRING_03:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_03
M_PRG_CONST_STRING_04:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (S1) - Laenge in R17
        LDI        ZL, LOW(S1)
        LDI        ZH, HIGH(S1)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_06
        MOV        R16, R17
M_PRG_CONST_STRING_05:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_05
M_PRG_CONST_STRING_06:
        ST         -Z, R17
 
; PROCEDURE - Ende (SENDE_STRING)
        RET
 
; PROCEDURE - Anfang (BYTETOSTRING)
BYTETOSTRING:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (WERT_BYTE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0xF0)
        LDI        R18, 0xF0
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; SHR(HEXHIGH) - Byte
        LSR        R2
 
; SHR(HEXHIGH) - Byte
        LSR        R2
 
; SHR(HEXHIGH) - Byte
        LSR        R2
 
; SHR(HEXHIGH) - Byte
        LSR        R2
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x09)
        LDI        R18, 0x09
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_010
        CLR        R16
        RJMP       M_VERGL_011
M_VERGL_010:
        SER        R16
M_VERGL_011:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_07
        RJMP       M_IF_08
M_IF_07:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x37)
        LDI        R18, 0x37
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_09
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_08:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x30)
        LDI        R18, 0x30
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; IF_THEN_ELSE - Ende
M_IF_09:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung ByteToChar(HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R3, R16
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (WRITE_STRING)=20
        LDI        R16, 20
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (C1)
        MOV        R19, R3
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_012
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_012:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WRITE_STRING) - Laenge in R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_014
        MOV        R16, R17
M_PRG_CONST_STRING_013:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_013
M_PRG_CONST_STRING_014:
        ST         -Z, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (WERT_BYTE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0F)
        LDI        R18, 0x0F
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x09)
        LDI        R18, 0x09
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_018
        CLR        R16
        RJMP       M_VERGL_019
M_VERGL_018:
        SER        R16
M_VERGL_019:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_015
        RJMP       M_IF_016
M_IF_015:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x37)
        LDI        R18, 0x37
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_017
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_016:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x30)
        LDI        R18, 0x30
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; IF_THEN_ELSE - Ende
M_IF_017:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung ByteToChar(HEXLOW)
        MOV        R16, R1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R3, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (WRITE_STRING)=20
        LDI        R16, 20
        CLR        R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_020
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_020:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_022
M_PRG_CONST_STRING_021:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_021
M_PRG_CONST_STRING_022:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (C1)
        MOV        R19, R3
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_023
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_023:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WRITE_STRING) - Laenge in R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_025
        MOV        R16, R17
M_PRG_CONST_STRING_024:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_024
M_PRG_CONST_STRING_025:
        ST         -Z, R17
 
; PROCEDURE - Ende (BYTETOSTRING)
        RET
 
; Start des Hauptprogramms
RESET:
 
; Initialisieren des Stacks
        LDI        R16, LOW(RAMEND)
        OUT        SPL, R16
        LDI        R16, HIGH(RAMEND)
        OUT        SPH, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x21)
        LDI        R16, 0x21
 
; Zuweisung Ziel /  VAR (RAM_ZELLE)
        STS        RAM_ZELLE, R16
 
; Byte-Parameter(1) fuer PROCEDURE (BYTETOSTRING)
        LDS        R0, RAM_ZELLE
 
; Aufruf PROCEDURE (BYTETOSTRING)
        CALL       BYTETOSTRING
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (WRITE_STRING)=20
        LDI        R16, 20
        CLR        R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Kopieren der String-Konstante in den Stack ('o')
        LDI        ZL, LOW(2*M_CONST_STRING_1)
        LDI        ZH, HIGH(2*M_CONST_STRING_1)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_026
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_026:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_028
M_PRG_CONST_STRING_027:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_027
M_PRG_CONST_STRING_028:
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_029
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_029:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_031
M_PRG_CONST_STRING_030:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_030
M_PRG_CONST_STRING_031:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WRITE_STRING) - Laenge in R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_033
        MOV        R16, R17
M_PRG_CONST_STRING_032:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_032
M_PRG_CONST_STRING_033:
        ST         -Z, R17
 
; *** Namen-Liste ***
;
; S1 (V) STRING
; WRITE_STRING (V) STRING
; C2 (V) CHAR
; RAM_ZELLE (V) BYTE
; SENDE_STRING (P) 
; BYTETOSTRING (P) 
 
; *** Prozedur/Function-Liste ***
;
; PROCEDURE SENDE_STRING (C1 : CHAR);
; PROCEDURE BYTETOSTRING (WERT_BYTE : BYTE) (HEXLOW : BYTE) (HEXHIGH : BYTE) (C1 : CHAR);
 
; *** Konstanten-STRING-Liste ***
;
 
M_CONST_STRING_0:
 .db    5, "Hallo"
 
M_CONST_STRING_1:
 .db    1, "o"
 
