; Assemblerquelltext des RONPAS-Compilers (c) by Ronald Daleske
; PROGRAM-NAME: TEST_CONST.PAS
 
.nolist
.INCLUDE "m328Pdef.inc"
.list
 
; *** Konstantentabelle ***
 
.equ        C_CURR_1  =  0x000000000000C350 ; CURRENCY
 
; *** Variablentabelle ***
 
.dseg
 
V_CURR_1:   ; Currency
.byte     8
V_CURR_2:   ; Currency
.byte     8
 
 
 
; *** Codesegment ***
.cseg
 
; *** Sprungtabelle ***
.ORG 0
 
; Sprung in das Hauptprogramm
        JMP       RESET
 
; FUNCTION - Anfang (AAA)
AAA:
 
; RESULT Currency-Variable - FUNCTION (AAA)
        MOV        R8, R0
        MOV        R9, R1
        MOV        R10, R2
        MOV        R11, R3
        MOV        R12, R4
        MOV        R13, R5
        MOV        R14, R6
        MOV        R15, R7
 
; Ende Currency - FUNCTION (AAA)
        MOV        R16, R8
        MOV        R17, R9
        MOV        R18, R10
        MOV        R19, R11
        MOV        R20, R12
        MOV        R21, R13
        MOV        R22, R14
        MOV        R23, R15
 
; FUNCTION - Ende (AAA)
        RET
 
; Start des Hauptprogramms
RESET:
 
; Initialisieren des Stacks
        LDI        R16, LOW(RAMEND)
        OUT        SPL, R16
        LDI        R16, HIGH(RAMEND)
        OUT        SPH, R16
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (C_CURR_1)
        LDI        R16, 0x50
        LDI        R17, 0xC3
        LDI        R18, 0x00
        LDI        R19, 0x00
        LDI        R20, 0x00
        LDI        R21, 0x00
        LDI        R22, 0x00
        LDI        R23, 0x00
 
; Zuweisung Ziel /  VAR (V_CURR_1)
        STS        V_CURR_1, R16
        STS        V_CURR_1+1, R17
        STS        V_CURR_1+2, R18
        STS        V_CURR_1+3, R19
        STS        V_CURR_1+4, R20
        STS        V_CURR_1+5, R21
        STS        V_CURR_1+6, R22
        STS        V_CURR_1+7, R23
 
; Zuweisung Quelle - Ausdruck / Currency-VAR (V_CURR_1)
        LDS        R16, V_CURR_1
        LDS        R17, V_CURR_1+1
        LDS        R18, V_CURR_1+2
        LDS        R19, V_CURR_1+3
        LDS        R20, V_CURR_1+4
        LDS        R21, V_CURR_1+5
        LDS        R22, V_CURR_1+6
        LDS        R23, V_CURR_1+7
 
; Zuweisung Ziel /  VAR (V_CURR_2)
        STS        V_CURR_2, R16
        STS        V_CURR_2+1, R17
        STS        V_CURR_2+2, R18
        STS        V_CURR_2+3, R19
        STS        V_CURR_2+4, R20
        STS        V_CURR_2+5, R21
        STS        V_CURR_2+6, R22
        STS        V_CURR_2+7, R23
 
; Currency-Parameter(1) fuer FUNCTION (AAA)
        LDI        R16, 0x50
        MOV        R0, R16
        LDI        R17, 0xC3
        MOV        R1, R17
        LDI        R18, 0x00
        MOV        R2, R18
        LDI        R19, 0x00
        MOV        R3, R19
        LDI        R20, 0x00
        MOV        R4, R20
        LDI        R21, 0x00
        MOV        R5, R21
        LDI        R22, 0x00
        MOV        R6, R22
        LDI        R23, 0x00
        MOV        R7, R23
 
; Aufruf Funktion (AAA)
        CALL       AAA
 
; Zuweisung Ziel /  VAR (V_CURR_2)
        STS        V_CURR_2, R16
        STS        V_CURR_2+1, R17
        STS        V_CURR_2+2, R18
        STS        V_CURR_2+3, R19
        STS        V_CURR_2+4, R20
        STS        V_CURR_2+5, R21
        STS        V_CURR_2+6, R22
        STS        V_CURR_2+7, R23
 
; *** Namen-Liste ***
;
; C_CURR_1 (C) CURRENCY Wert=50000
; V_CURR_1 (V) CURRENCY
; V_CURR_2 (V) CURRENCY
; AAA (F) 
 
; *** Prozedur/Function-Liste ***
;
; FUNCTION AAA (L_CURR_1 : CURRENCY) : CURRENCY;
 
