; Assemblerquelltext des RONPAS-Compilers (c) by Ronald Daleske
; PROGRAM-NAME: TEST_ARRAY.PAS
 
.nolist
.INCLUDE "m8def.inc"
.list
 
; *** Variablentabelle ***
 
.dseg
 
D1:   ; DWord
.byte     4
W1:   ; Word
.byte     2
 
 
 
; *** Codesegment ***
.cseg
 
; *** Sprungtabelle ***
.ORG 0
 
; Sprung in das Hauptprogramm
        RJMP       RESET
 
; Start des Hauptprogramms
RESET:
 
; Initialisieren des Stacks
        LDI        R16, LOW(RAMEND)
        OUT        SPL, R16
        LDI        R16, HIGH(RAMEND)
        OUT        SPH, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x007B)
        LDI        R16, LOW(0x007B)
        LDI        R17, HIGH(0x007B)
 
; Zuweisung Ziel /  VAR (W1)
        STS        W1, R16
        STS        W1+1, R17
 
; ARRAY - Ausdruck erster Faktor / Zahlenwert (0x0005)
        LDI        R16, LOW(0x0005)
        LDI        R17, HIGH(0x0005)
 
; ARRAY - Ausdruck zweiter Faktor / Word-VAR (W1)
        LDS        R18, W1
        LDS        R19, W1+1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Quelle - Ausdruck /; CONST ARRAY (SINTAB)
        LDI        ZL, LOW(2*SINTAB)
        LDI        ZH, HIGH(2*SINTAB)
        LSL        R16
        ROL        R17
        LSL        R16
        ROL        R17
        ADD        ZL, R16
        ADC        ZH, R17
        LPM        R16, Z+
        LPM        R17, Z+
        LPM        R18, Z+
        LPM        R19, Z+
 
; Zuweisung Ziel /  VAR (D1)
        STS        D1, R16
        STS        D1+1, R17
        STS        D1+2, R18
        STS        D1+3, R19
 
; *** Namen-Liste ***
;
; SINTAB (A) 
; D1 (V) DWORD
; W1 (V) WORD
 
; *** Konstanten-ARRAYs ***
;
 
SINTAB:
.dw    0x0000
.dw    0x0000
.dw    0xC2CB
.dw    0x0477
.dw    0x2C65
.dw    0x08EF
.dw    0xE3A4
.dw    0x0D65
.dw    0x8F6D
.dw    0x11DB
.dw    0xD6B9
.dw    0x164F
.dw    0x609B
.dw    0x1AC2
.dw    0xD44C
.dw    0x1F32
.dw    0xD92D
.dw    0x23A0
.dw    0x16CF
.dw    0x280C
.dw    0x34FC
.dw    0x2C74
.dw    0xDBBB
.dw    0x30D8
.dw    0xB358
.dw    0x3539
.dw    0x646D
.dw    0x3996
.dw    0x97E6
.dw    0x3DEE
.dw    0xF706
.dw    0x4241
.dw    0x2B75
.dw    0x4690
.dw    0xDF3E
.dw    0x4AD8
.dw    0xBCDC
.dw    0x4F1B
.dw    0x6F40
.dw    0x5358
.dw    0xA1D2
.dw    0x578E
.dw    0x007F
.dw    0x5BBE
.dw    0x37BB
.dw    0x5FE6
.dw    0xF48A
.dw    0x6406
.dw    0xE484
.dw    0x681F
.dw    0xB5DC
.dw    0x6C30
.dw    0x176B
.dw    0x7039
.dw    0xB8AD
.dw    0x7438
.dw    0x49D0
.dw    0x782F
.dw    0x7BB7
.dw    0x7C1C
.dw    0x0000
.dw    0x8000
.dw    0x8907
.dw    0x83D9
.dw    0xC9F5
.dw    0x87A8
.dw    0x76BB
.dw    0x8B6D
.dw    0x4420
.dw    0x8F27
.dw    0xE7C3
.dw    0x92D5
.dw    0x1823
.dw    0x9679
.dw    0x8CA2
.dw    0x9A10
.dw    0xFD8D
.dw    0x9D9B
.dw    0x2422
.dw    0xA11B
.dw    0xBA91
.dw    0xA48D
.dw    0x7C09
.dw    0xA7F3
.dw    0x24B6
.dw    0xAB4C
.dw    0x71CC
.dw    0xAE97
.dw    0x2186
.dw    0xB1D5
.dw    0xF333
.dw    0xB504
.dw    0xA734
.dw    0xB826
.dw    0xFF06
.dw    0xBB39
.dw    0xBD41
.dw    0xBE3E
.dw    0xA5A4
.dw    0xC134
.dw    0x7D16
.dw    0xC41B
.dw    0x09A8
.dw    0xC6F3
.dw    0x129F
.dw    0xC9BB
.dw    0x6074
.dw    0xCC73
.dw    0xBCDC
.dw    0xCF1B
.dw    0xF2C8
.dw    0xD1B3
.dw    0xCE6C
.dw    0xD43B
.dw    0x1D45
.dw    0xD6B3
.dw    0xAE16
.dw    0xD919
.dw    0x50F3
.dw    0xDB6F
.dw    0xD742
.dw    0xDDB3
.dw    0x13BE
.dw    0xDFE7
.dw    0xDA7B
.dw    0xE208
.dw    0x00E9
.dw    0xE419
.dw    0x5DDA
.dw    0xE617
.dw    0xC981
.dw    0xE803
.dw    0x1D77
.dw    0xE9DE
.dw    0x34C0
.dw    0xEBA6
.dw    0xEBCC
.dw    0xED5B
.dw    0x2077
.dw    0xEEFF
.dw    0xB212
.dw    0xF08F
.dw    0x815F
.dw    0xF20D
.dw    0x7099
.dw    0xF378
.dw    0x6373
.dw    0xF4D0
.dw    0x3F1A
.dw    0xF615
.dw    0xEA39
.dw    0xF746
.dw    0x4CFB
.dw    0xF865
.dw    0x5109
.dw    0xF970
.dw    0xE193
.dw    0xFA67
.dw    0xEB49
.dw    0xFB4B
.dw    0x5C63
.dw    0xFC1C
.dw    0x24A1
.dw    0xFCD9
.dw    0x3549
.dw    0xFD82
.dw    0x812C
.dw    0xFE17
.dw    0xFCA7
.dw    0xFE98
.dw    0x9DA0
.dw    0xFF06
.dw    0x5B8B
.dw    0xFF60
.dw    0x2F68
.dw    0xFFA6
.dw    0x13C5
.dw    0xFFD8
.dw    0x04BF
.dw    0xFFF6
.dw    0xFFFF
.dw    0xFFFF
 
